(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('zdog')) :
  typeof define === 'function' && define.amd ? define(['exports', 'zdog'], factory) :
  (global = global || self, factory(global.VueZDog = {}, global.Zdog));
}(this, function (exports, Zdog) { 'use strict';

  Zdog = Zdog && Zdog.hasOwnProperty('default') ? Zdog['default'] : Zdog;

  //

  function _async(f) {
    return function () {
      var arguments$1 = arguments;

      for (var args = [], i = 0; i < arguments.length; i++) {
        args[i] = arguments$1[i];
      }

      try {
        return Promise.resolve(f.apply(this, args));
      } catch (e) {
        return Promise.reject(e);
      }
    };
  }

  var props = {
    svg: {
      type: Boolean
    },
    resize: {
      type: [Boolean, String]
    },
    dragRotate: {
      type: Boolean
    },
    zoom: {
      type: Number
    },
    centered: {
      type: Boolean
    }
  };

  function _await(value, then, direct) {
    if (direct) {
      return then ? then(value) : value;
    }

    if (!value || !value.then) {
      value = Promise.resolve(value);
    }

    return then ? value.then(then) : value;
  }

  var script = {
    name: 'ZIllustration',
    props: Object.assign({}, props, {
      autoRendering: {
        default: true,
        type: Boolean
      }
    }),

    provide: function provide() {
      var this$1 = this;

      var _this = this;

      var vm = this;
      return {
        zdog: {
          get parent() {
            return vm.__zIllustration;
          },

          notifyUpdate: function () {
            this$1.$nextTick(function () {
              this$1.$emit('zdog:update');
            });
          },
          onReady: _async(function () {
            return _this.__readyPromise;
          })
        }
      };
    },

    created: _async(function () {
      var _this2 = this;

      _this2.__readyPromise = new Promise(function (resolve) {
        _this2.$once('zdog:ready', resolve);
      });
      return _await(_this2.__readyPromise, function () {
        _this2.animate();

        _this2.$watch('autoRendering', _this2.animate);
      });
    }),

    mounted: function mounted() {
      this.__zIllustration = new Zdog.Illustration(Object.assign({
        element: this.$el
      }, this.zDogsProps));
      this.$emit('zdog:ready', this.__zIllustration); // this.$on('zdog:update', () => {
      //   this.__zIllustration.updateRenderGraph()
      // })
    },

    computed: {
      zDogsProps: function zDogsProps() {
        var this$1 = this;

        return Object.keys(props).reduce(function (obj, key) {
          var obj$1;

          return Object.assign({}, obj, ( obj$1 = {}, obj$1[key] = this$1.$props[key], obj$1 ));
        }, {});
      }

    },
    methods: {
      animate: function animate() {
        this.__zIllustration.updateRenderGraph();

        this.$emit('tick');
        if (this.autoRendering) { requestAnimationFrame(this.animate); }
      }

    },

    destroyed: function destroyed() {}

  };

  function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier
  /* server only */
  , shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
      createInjectorSSR = createInjector;
      createInjector = shadowMode;
      shadowMode = false;
    } // Vue.extend constructor export interop.


    var options = typeof script === 'function' ? script.options : script; // render functions

    if (template && template.render) {
      options.render = template.render;
      options.staticRenderFns = template.staticRenderFns;
      options._compiled = true; // functional template

      if (isFunctionalTemplate) {
        options.functional = true;
      }
    } // scopedId


    if (scopeId) {
      options._scopeId = scopeId;
    }

    var hook;

    if (moduleIdentifier) {
      // server build
      hook = function hook(context) {
        // 2.3 injection
        context = context || // cached call
        this.$vnode && this.$vnode.ssrContext || // stateful
        this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext; // functional
        // 2.2 with runInNewContext: true

        if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
          context = __VUE_SSR_CONTEXT__;
        } // inject component styles


        if (style) {
          style.call(this, createInjectorSSR(context));
        } // register component module identifier for async chunk inference


        if (context && context._registeredComponents) {
          context._registeredComponents.add(moduleIdentifier);
        }
      }; // used by ssr in case component is cached and beforeCreate
      // never gets called


      options._ssrRegister = hook;
    } else if (style) {
      hook = shadowMode ? function () {
        style.call(this, createInjectorShadow(this.$root.$options.shadowRoot));
      } : function (context) {
        style.call(this, createInjector(context));
      };
    }

    if (hook) {
      if (options.functional) {
        // register for functional component in vue file
        var originalRender = options.render;

        options.render = function renderWithStyleInjection(h, context) {
          hook.call(context);
          return originalRender(h, context);
        };
      } else {
        // inject component registration as beforeCreate hook
        var existing = options.beforeCreate;
        options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
      }
    }

    return script;
  }

  var normalizeComponent_1 = normalizeComponent;

  /* script */
  var __vue_script__ = script;
  /* template */

  var __vue_render__ = function () {
    var _vm = this;

    var _h = _vm.$createElement;

    var _c = _vm._self._c || _h;

    return !_vm.svg ? _c('canvas', _vm._b({}, 'canvas', _vm.$attrs, false), [_vm._t("default")], 2) : _c('svg', _vm._b({}, 'svg', _vm.$attrs, false), [_vm._t("default")], 2);
  };

  var __vue_staticRenderFns__ = [];
  /* style */

  var __vue_inject_styles__ = undefined;
  /* scoped */

  var __vue_scope_id__ = undefined;
  /* module identifier */

  var __vue_module_identifier__ = undefined;
  /* functional template */

  var __vue_is_functional_template__ = false;
  /* style inject */

  /* style inject SSR */

  var ZIllustration = normalizeComponent_1({
    render: __vue_render__,
    staticRenderFns: __vue_staticRenderFns__
  }, __vue_inject_styles__, __vue_script__, __vue_scope_id__, __vue_is_functional_template__, __vue_module_identifier__, undefined, undefined);

  function _await$1(value, then, direct) {
    if (direct) {
      return then ? then(value) : value;
    }

    if (!value || !value.then) {
      value = Promise.resolve(value);
    }

    return then ? value.then(then) : value;
  }

  function _async$1(f) {
    return function () {
      var arguments$1 = arguments;

      for (var args = [], i = 0; i < arguments.length; i++) {
        args[i] = arguments$1[i];
      }

      try {
        return Promise.resolve(f.apply(this, args));
      } catch (e) {
        return Promise.reject(e);
      }
    };
  }

  var ZShapeFactory = (function (shapeName, extendedProps) {
    var props = Object.assign({
      // ZDOG API
      translate: {
        type: Object
      },
      // TODO add custom validators
      rotate: {
        type: Object
      },
      scale: {
        type: Object
      }
    }, extendedProps);
    return {
      name: ("Z" + shapeName),
      inject: ["zdog"],

      provide: function provide() {
        var vm = this;
        var zdog = Object.assign({}, vm.zdog);
        Object.defineProperty(zdog, "parent", {
          get: function get() {
            return vm.__zEl;
          }

        });
        return {
          zdog: zdog
        };
      },

      props: props,
      created: _async$1(function () {
        var _this = this;

        _this.__zEl = new Zdog[shapeName]();

        _this.setupPropWatcher();

        return _await$1(_this.zdog.onReady(), function () {
          _this.zdog.parent.addChild(_this.__zEl);

          _this.zdog.notifyUpdate();
        });
      }),

      destroyed: function destroyed() {
        this.zdog.parent.removeChild(this.__zEl);
        this.zdog.notifyUpdate();
      },

      methods: {
        setupPropWatcher: function setupPropWatcher() {
          var this$1 = this;

          var createHandler = function (name) { return function (newVal) {
            this$1.__zEl[name] = newVal;
            this$1.__zEl.updatePath && this$1.__zEl.updatePath(); // no setters yet in the API we need to explicitly refresh the shape

            this$1.zdog.notifyUpdate();
          }; };

          var loop = function () {
            var key = list[i];

            this$1.$watch(function () { return this$1.$props[key]; }, createHandler(key), {
              immediate: true,
              deep: true
            });
          };

          for (var i = 0, list = Object.keys(props); i < list.length; i += 1) loop();
        }

      },

      render: function render(h) {
        return h("div", this.$slots.default);
      }

    };
  });

  var commonShapeProps = {
    stroke: {
      type: [Number, Boolean]
    },
    fill: {
      type: Boolean
    },
    color: {
      type: String
    },
    closed: {
      type: Boolean,
      default: true
    },
    visible: {
      type: Boolean,
      default: true
    },
    backface: {
      type: [String, Boolean],
      default: true
    }
  };
  var ZAnchor = ZShapeFactory("Anchor", {});
  var ZRect = ZShapeFactory("Rect", Object.assign({}, commonShapeProps, {
    width: {
      required: true,
      type: Number
    },
    height: {
      required: true,
      type: Number
    }
  }));
  var ZRoundedRect = ZShapeFactory("RoundedRect", Object.assign({}, commonShapeProps, {
    width: {
      required: true,
      type: Number
    },
    height: {
      required: true,
      type: Number
    },
    cornerRadius: {
      type: Number
    }
  }));
  var ZEllipse = ZShapeFactory("Ellipse", Object.assign({}, commonShapeProps, {
    width: {
      type: Number
    },
    height: {
      type: Number
    },
    diameter: {
      type: Number
    },
    quarters: {
      type: Number
    }
  }));
  var ZPolygon = ZShapeFactory("Polygon", Object.assign({}, commonShapeProps, {
    radius: {
      required: true,
      type: Number
    },
    sides: {
      required: true,
      type: Number
    }
  }));
  var ZPath = ZShapeFactory("Path", Object.assign({}, commonShapeProps, {
    path: {
      required: true,
      type: Array
    },
    closed: {
      type: Boolean
    }
  }));
  var ZHemisphere = ZShapeFactory("Hemisphere", Object.assign({}, commonShapeProps, {
    diameter: {
      required: true,
      type: Number
    }
  }));
  var ZCone = ZShapeFactory("Cone", Object.assign({}, commonShapeProps, {
    diameter: {
      required: true,
      type: Number
    },
    length: {
      required: true,
      type: Number
    }
  }));
  var ZCylinder = ZShapeFactory("Cylinder", Object.assign({}, commonShapeProps, {
    diameter: {
      required: true,
      type: Number
    },
    length: {
      required: true,
      type: Number
    },
    frontFace: {
      type: [String, Boolean],
      default: true
    },
    backFace: {
      type: [String, Boolean],
      default: true
    }
  }));
  var ZBox = ZShapeFactory("Box", Object.assign({}, commonShapeProps, {
    width: {
      required: true,
      type: Number
    },
    height: {
      required: true,
      type: Number
    },
    depth: {
      required: true,
      type: Number
    },
    leftFace: {
      type: [String, Boolean],
      default: true
    },
    rightFace: {
      type: [String, Boolean],
      default: true
    },
    rearFace: {
      type: [String, Boolean],
      default: true
    },
    frontFace: {
      type: [String, Boolean],
      default: true
    },
    topFace: {
      type: [String, Boolean],
      default: true
    },
    bottomFace: {
      type: [String, Boolean],
      default: true
    }
  }));

  exports.ZAnchor = ZAnchor;
  exports.ZBox = ZBox;
  exports.ZCone = ZCone;
  exports.ZCylinder = ZCylinder;
  exports.ZEllipse = ZEllipse;
  exports.ZHemisphere = ZHemisphere;
  exports.ZIllustration = ZIllustration;
  exports.ZPath = ZPath;
  exports.ZPolygon = ZPolygon;
  exports.ZRect = ZRect;
  exports.ZRoundedRect = ZRoundedRect;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
